import uuid

from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("documents", "0011_alter_classification_confidence"),
    ]

    operations = [
        migrations.RunSQL(
            [
                # On databases created after Django 4.1, drop the GENERATED BY DEFAULT AS IDENTITY constraint.
                "ALTER TABLE documents_transcriptionentity ALTER COLUMN id DROP IDENTITY IF EXISTS",
                # On databases that existed before Django 4.1, manually drop the auto increment ID sequence.
                "ALTER TABLE documents_transcriptionentity ALTER COLUMN id DROP DEFAULT",
                "DROP SEQUENCE IF EXISTS documents_transcriptionentity_id_seq",
                # No other table relies on TranscriptionEntity at the time of the migration, just update its PK.
                "ALTER TABLE documents_transcriptionentity ALTER COLUMN id TYPE uuid USING gen_random_uuid()",
                "ALTER TABLE documents_transcriptionentity ALTER COLUMN id SET DEFAULT gen_random_uuid()",
            ],
            reverse_sql=[
                "CREATE SEQUENCE documents_transcriptionentity_id_seq START 1",
                "ALTER TABLE documents_transcriptionentity ALTER COLUMN id DROP DEFAULT",
                """
                ALTER TABLE documents_transcriptionentity
                ALTER COLUMN id TYPE integer
                USING nextval('documents_transcriptionentity_id_seq'::regclass)
                """,
                """
                ALTER TABLE documents_transcriptionentity
                ALTER COLUMN id SET DEFAULT nextval('documents_transcriptionentity_id_seq'::regclass)
                """,
            ],
            state_operations=[
                migrations.AlterField(
                    model_name="transcriptionentity",
                    name="id",
                    field=models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False),
                ),
            ],
        )
    ]
